(* tests for ME/rewrite.sml
   TODO.WN0509 collect typical tests from systest here !!!!!
   author: Walther Neuper 050908
   (c) copyright due to lincense terms.

use"../smltest/Scripts/rewrite.sml";
use"rewrite.sml";
*)
"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- rewrite_terms_  -------------------------------------";
"----------- rewrite_inst_ bdvs ----------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";


"----------- rewrite_terms_  -------------------------------------";
"----------- rewrite_terms_  -------------------------------------";
"----------- rewrite_terms_  -------------------------------------";
val subte = [str2term"x = 0"];
val t = str2term"M_b x = -1 * q_0 * x ^^^ 2 / 2 + x * c + c_2";
val Some (t',_) = rewrite_terms_ thy dummy_ord Erls subte t;
if term2str t' = "M_b 0 = -1 * q_0 * 0 ^^^ 2 / 2 + 0 * c + c_2" then ()
else raise error "rewrite.sml rewrite_terms_ [x = 0]";

val subte = [str2term"M_b 0 = 0"];
val t = str2term"M_b 0 = -1 * q_0 * 0 ^^^ 2 / 2 + 0 * c + c_2";
val Some (t',_) = rewrite_terms_ thy dummy_ord Erls subte t;
if term2str t' = "0 = -1 * q_0 * 0 ^^^ 2 / 2 + 0 * c + c_2" then ()
else raise error "rewrite.sml rewrite_terms_ [M_b 0 = 0]";

val subte = [str2term"x = 0", str2term"M_b 0 = 0"];
val t = str2term"M_b x = -1 * q_0 * x ^^^ 2 / 2 + x * c + c_2";
val Some (t',_) = rewrite_terms_ thy dummy_ord Erls subte t;
if term2str t' = "0 = -1 * q_0 * 0 ^^^ 2 / 2 + 0 * c + c_2" then ()
else raise error "rewrite.sml rewrite_terms_ [x = 0, M_b 0 = 0]";


"----------- rewrite_inst_ bdvs ----------------------------------";
"----------- rewrite_inst_ bdvs ----------------------------------";
"----------- rewrite_inst_ bdvs ----------------------------------";
(*see smltest/Scripts/term_G.sml: inst_bdv 2*)
val t = str2term"-1 * (q_0 * L ^^^ 2) / 2 + (L * c_3 + c_4) = 0";
val bdvs = [(str2term"bdv_1",str2term"c"),
	    (str2term"bdv_2",str2term"c_2"),
	    (str2term"bdv_3",str2term"c_3"),
	    (str2term"bdv_4",str2term"c_4")];
(*------------ outcommented WN071210, after inclusion into ROOT.ML 
val Some (t,_) = 
    rewrite_inst_ thy e_rew_ord 
		  (append_rls "erls_isolate_bdvs" e_rls 
			      [(Calc ("EqSystem.occur'_exactly'_in", 
				      eval_occur_exactly_in 
					  "#eval_occur_exactly_in_"))
			       ]) 
		  false bdvs (num_str separate_bdvs_add) t;
(writeln o term2str) t;
if term2str t = "L * c_3 + c_4 = 0 + -1 * (-1 * (q_0 * L ^^^ 2) / 2)"
then () else raise error "rewrite.sml rewrite_inst_ bdvs";
trace_rewrite:=true;
trace_rewrite:=false;--------------------------------------------*)

