/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2007 by Walther Neuper
 * created Oct 4, 2007 4:59:04 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.bridge;

/**
 * This is the superclass of CMessage and CEvent; these classes are instantiated
 * _before_ the CalcTree is easily available (WN0710 in the present MathEngine);
 * CalcTree is added later leading to the analoguous classes ...
 * 
 * @see isac.util.CalcEvent ... which additionally contain the CalcTree.
 * 
 * @author Walther Neuper
 * 
 */
public class CEvent {

}
