(*.evaluate isac (all the code of the kernel) and isactest
   (c) Walther Neuper 1997

  /usr/local/Isabelle2002/bin/isabelle HOL-Real-Isac

  /usr/local/Isabelle2002/bin/isabelle HOL-Real
  cd"~/proto2/isac/src/sml";
  use"RTEST-root.sml";

  use"ROOT.ML";
  use"RCODE-root.sml";
.*)
 
"**** run the tests **************************************";
cd "systest";
(*+ check kbtest/diffapp.sml for additional items in met-model*)
       	use"root-equ.sml"; 
       	use"script.sml";   
	(* use"script_if.sml"; WN03 missing: is_rootequation_in*)
       	use"scriptnew.sml";     
       	use"subp-rooteq.sml";   
	use"tacis.sml";
	use"interface-xml.sml";
	(* use"testdaten.sml"; no update after dropping 'errorBound'*)    
 	cd "../..";
"**** run systests complete ******************************";

cd"smltest/Scripts";
 	use"calculate-float.sml";
 	use"calculate.sml";
	use"listg.sml";
	use"rewrite.sml";
 	use"scrtools.sml";
 	use"term_G.sml";
 	use"tools.sml";
 	cd "../.."; 
cd"smltest/ME";
        use"ctree.sml";
       	use"calchead.sml"; 
 	use"rewtools.sml";
        use"solve.sml"; (*detailrls can notyet ackn. 'Rewrite_Set "cancel"' *);
        use"inform.sml";
	use"me.sml";
       	use"ptyps.sml"; 
 	cd "../.."; 
cd"smltest/xmlsrc";
 	use"datatypes.sml";        
       	use"pbl-met-hierarchy.sml"; 
       	use"thy-hierarchy.sml"; 
 	cd "../.."; 
cd"smltest/FE-interface";
       	use"interface.sml";
 	cd "../.."; 
"**** run tests on math-engine complete ******************";
cd"smltest/IsacKnowledge";
        use"atools.sml";
 	use"complex.sml";
 	use"diff.sml";
 	use"diffapp.sml";
	(*use"integrate.sml";TODO.new_c: cvs before 071227, 11:50*)
	use"equation.sml";
	(*use"inssort.sml"; problems with recdef in Isabelle2002*)
 	use"logexp.sml";
 	use"poly.sml";
 	use"polyminus.sml";
 	use"polyeq.sml";  (*TODO 31.b, n1., 44.a, 1.a~, 1.b (all'expanded')WN
 			     ? also check others without check 'diff.behav.'*);
 	use"rateq.sml";
 	use"rational.sml" (*TODO add_fractions_p throws overflow-exn      WN*);
 	use"rlang.sml";    (*WN.12.6.03: for TODOs search 'writeln', 
 			     for simplification search MG 
 		 erls:       98a(1) 104a(1) 104a(2) 68a *);
 	use"root.sml";
 	use"rooteq.sml";
 	use"rootrateq.sml";
 	use"termorder.sml";
 	use"trig.sml";
 	use"vect.sml";  
	use"wn.sml";
	use"eqsystem.sml";
	(*use"biegelinie.sml";TODO.new_c: cvs before 071227, 11:50*)
	use"algein.sml";
 	cd "../.."; 
"**** run tests on IsacKnowledge complete ****************";

val path = "/home/neuper/proto2/testsml2xml/"; 
pbl_hierarchy2file (path ^ "pbl/");
pbls2file          (path ^ "pbl/");
met_hierarchy2file (path ^ "met/");
mets2file          (path ^ "met/");
thy_hierarchy2file (path ^ "thy/");
thes2file          (path ^ "thy/");
"**** tested creation of xmldata *************************";

cd"sml";
states:=[];
"=========================================================";

"**** run systests complete ***************** re-organize!";
"**** run tests on math-engine complete ******************";
"**** run tests on IsacKnowledge complete ****************";
"**** build isac kernel + run tests complete *************";
"**** tested creation of xmldata *************************";
